--- old/usr/src/cmd/printf/printf.c	Thu May  8 09:00:23 2014
+++ new/usr/src/cmd/printf/printf.c	Thu May  8 09:00:23 2014
@@ -92,7 +92,7 @@
 main(int argc, char *argv[])
 {
 	size_t len;
-	int chopped, end, rval;
+	int end, rval;
 	char *format, *fmt, *start;
 
 	(void) setlocale(LC_ALL, "");
@@ -124,7 +124,7 @@
 	 * up the format string.
 	 */
 	fmt = format = *argv;
-	chopped = escape(fmt, 1, &len);		/* backslash interpretation */
+	(void) escape(fmt, 1, &len);	/* backslash interpretation */
 	rval = end = 0;
 	gargv = ++argv;
 
@@ -162,7 +162,7 @@
 			return (1);
 		}
 		(void) fwrite(start, 1, PTRDIFF(fmt, start), stdout);
-		if (chopped || !*gargv)
+		if (!*gargv)
 			return (rval);
 		/* Restart at the beginning of the format string. */
 		fmt = format;
@@ -338,13 +338,11 @@
 			return (NULL);
 		}
 		getout = escape(p, 0, &len);
-		*(fmt - 1) = 's';
-		PF(start, p);
-		*(fmt - 1) = 'b';
+		(void) fputs(p, stdout);
 		free(p);
 
 		if (getout)
-			return (fmt);
+			exit(*rval);
 		break;
 	}
 	case 'c': {
@@ -456,9 +454,13 @@
 			*store = '\b';
 			break;
 		case 'c':
-			*store = '\0';
-			*len = PTRDIFF(store, save);
-			return (1);
+			if (!percent) {
+				*store = '\0';
+				*len = PTRDIFF(store, save);
+				return (1);
+			}
+			*store = 'c';
+			break;
 		case 'f':		/* form-feed */
 			*store = '\f';
 			break;
--- old/usr/src/test/Makefile	Thu May  8 09:00:23 2014
+++ new/usr/src/test/Makefile	Thu May  8 09:00:23 2014
@@ -11,10 +11,11 @@
 
 #
 # Copyright (c) 2012 by Delphix. All rights reserved.
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 .PARALLEL: $(SUBDIRS)
 
-SUBDIRS = os-tests test-runner zfs-tests
+SUBDIRS = os-tests test-runner util-tests zfs-tests
 
 include Makefile.com
--- old/usr/src/test/util-tests/tests/printf/printf_test.ksh	Thu May  8 09:00:23 2014
+++ new/usr/src/test/util-tests/tests/printf/printf_test.ksh	Thu May  8 09:00:23 2014
@@ -18,16 +18,16 @@
 PRINTF=${PRINTF:=/usr/bin/printf}
 
 test_start() {
-        print "TEST STARTING ${1}: ${2}"
+	print "TEST STARTING ${1}: ${2}"
 }
 
 test_pass() {
-        print "TEST PASS: ${1}"
+	print "TEST PASS: ${1}"
 }
 
 test_fail() {
-        print "TEST FAIL: ${1}: ${2}"
-#        exit -1
+	print "TEST FAIL: ${1}: ${2}"
+	exit -1
 }
 
 checkrv() {
@@ -143,20 +143,36 @@
 tests[15][args]="one two"
 tests[15][result]='one!two'
 
-# this is not yet supported
-#typeset -A tests[16]=()
-#tests[16][desc]="backslash string (%b)"
-#tests[16][format]='%b'
-#tests[16][args]='\0101\0102\0103'
-#tests[16][result]='ABC'
+typeset -A tests[16]=()
+tests[16][desc]="backslash string (%b)"
+tests[16][format]='%b'
+tests[16][args]='\0101\0102\0103'
+tests[16][result]='ABC'
 
-# nor is this
-#typeset -A tests[17]=()
-#tests[17][desc]="backslash c in %b"
-#tests[17][format]='%b%s'
-#tests[17][args]='\0101\cone two'
-#tests[17][result]='A'
+typeset -A tests[17]=()
+tests[17][desc]="backslash c in %b"
+tests[17][format]='%b%s'
+tests[17][args]='\0101\cone two'
+tests[17][result]='A'
 
+typeset -A tests[18]=()
+tests[18][desc]="backslash octal in format"
+tests[18][format]='HI\1120K\0112tabbed\11again'
+tests[18][args]=
+tests[18][result]='HIJ0K	2tabbed	again'
+
+typeset -A tests[19]=()
+tests[19][desc]="backslash octal in %b"
+tests[19][format]="%b"
+tests[19][args]='HI\0112K\011tabbed'
+tests[19][result]='HIJK	tabbed'
+
+typeset -A tests[20]=()
+tests[20][desc]="numeric %d and ASCII conversions"
+tests[20][format]='%d '
+tests[20][args]="3 +3 -3 \"3 \"+ '-"
+tests[20][result]='3 3 -3 51 43 45 '
+
 #debug=yes
 
 for i in "${!tests[@]}"; do
